Attribute VB_Name = "Module1"
Option Explicit
Global Const MAXSTEP = 400  'Max number of steps
Global Const CHECKED = 1
Global Const UNCHECKED = 0

Global Const LEFT = 1
Global Const RIGHT = 2
Global Const UP = 3
Global Const Down = 4

Global Const ERASEP = -1
Global Const EMPTYP = 0
Global Const BLACKP = 1
Global Const WHITEP = 2
Global Const BOLDP = 3

Global TURN As Integer

Global MYCOLOR, HISCOLOR As Integer
Global Step As Integer
Global Msg_No As Integer
Global Hand As Integer
Global Current As Boolean


Global HOST As Integer
Global Const SERVER = 0
Global Const CLIENT = 1

Global Black_Name As String
Global White_Name As String
Global Add_Message As String

Global ModemState As Integer
Global SocketState As Integer
Global PlayState As Integer

Global Const CONNECTED = 1
Global Const UNCONNECTED = 0
Global S_R As Integer  'Send Ready
Global R_R As Integer  'Receive Ready
Global Side As Integer 'Which side I am taking

Global Const IDLE = 0
Global Const BUSY = 1
Global Const NODIALTONE = 2
Global Const NOCARRIER = 3
Global Const CONNECT = 4
Global Const FAILED = 5
Global Const LOGIN = 6

Global Const GIVEUP = -1
Global Const PLAY = 2
Global Const COUNTAREA = 3
Global Const TALK = 4
Global Const FINISHED = -4
Global Const UNDO = -2
Global Const LOGOUT = -3

Global g_ErrorCode As Integer
Global ParseArray(5)

Public Type Stone
Color As Integer
X As Integer
Y As Integer
Eat As Boolean 'Did it eat some stone?
End Type

Public Type MyPoint
Color As Integer
X As Integer
Y As Integer
Status As Integer
Gas As Integer
Current As Boolean
End Type

Public Type Message
No As Integer
Color As Integer
X As Variant
Y As Variant
E As String
End Type

Global Msg(1 To MAXSTEP) As Message
Global Board(1 To 19, 1 To 19) As MyPoint
Global Record(1 To MAXSTEP) As Stone
Public Function Count_Gas(p As MyPoint) As Integer
Dim l, r, u, d As Integer
Dim lx, ly, rx, ry, ux, uy, dx, dy As Integer
Dim lc, ls, lg, rc, rs, rg, uc, us, ug, dc, ds, du, dg As Integer
Dim nogas As Boolean
Dim ltp, rtp, utp, dtp As MyPoint

nogas = No_Gas(p)
    lx = Near_Point(LEFT, p).X
    ly = Near_Point(LEFT, p).Y
    rx = Near_Point(RIGHT, p).X
    ry = Near_Point(RIGHT, p).Y
    ux = Near_Point(UP, p).X
    uy = Near_Point(UP, p).Y
    dx = Near_Point(Down, p).X
    dy = Near_Point(Down, p).Y
    
    If lx = 0 Then
        lc = BOLDP
        ls = CHECKED
        lg = 0
    Else
        lc = Board(lx, ly).Color
        ls = Board(lx, ly).Status
        lg = Board(lx, ly).Gas
    End If
    
    If rx = 20 Then
        rc = BOLDP
        rs = CHECKED
        rg = 0
    Else
        rc = Board(rx, ry).Color
        rs = Board(rx, ry).Status
        rg = Board(rx, ry).Gas
    End If
    
    If uy = 0 Then
        uc = BOLDP
        us = CHECKED
        ug = 0
    Else
        uc = Board(ux, uy).Color
        us = Board(ux, uy).Status
        ug = Board(ux, uy).Gas
    End If
    
    If dy = 20 Then
        dc = BOLDP
        ds = CHECKED
        dg = 0
    Else
        dc = Board(dx, dy).Color
        ds = Board(dx, dy).Status
        dg = Board(dx, dy).Gas
    End If
    
If nogas = False Then
Count_Gas = 1
Board(p.X, p.Y).Gas = 1
Board(p.X, p.Y).Status = CHECKED
    If (lx > 0 And lx < 20 And ly > 0 And ly < 20) Then
        If Board(lx, ly).Color = p.Color Then
            Board(lx, ly).Gas = 1
            Board(lx, ly).Status = CHECKED
        End If
    End If
    
    If (rx > 0 And rx < 20 And ry > 0 And ry < 20) Then
        If Board(rx, ry).Color = p.Color Then
            Board(rx, ry).Gas = 1
            Board(rx, ry).Status = CHECKED
        End If
    End If
    
    If (ux > 0 And ux < 20 And uy > 0 And uy < 20) Then
        If Board(ux, uy).Color = p.Color Then
            Board(ux, uy).Gas = 1
            Board(ux, uy).Status = CHECKED
        End If
    End If
    
    If (dx > 0 And dx < 20 And dy > 0 And dy < 20) Then
        If Board(dx, dy).Color = p.Color Then
            Board(dx, dy).Gas = 1
            Board(dx, dy).Status = CHECKED
        End If
    End If
Exit Function
End If

If nogas = True Then
    Board(p.X, p.Y).Status = CHECKED
    l = r = u = d = 0
    If lc = EMPTYP Then
        l = 1
        GoTo out
        Else
        If lc = BOLDP Or lc <> p.Color Then
            l = 0
            Else
            If ls = CHECKED And lg = 1 Then
                l = 1
                GoTo out
                Else
                If ls = UNCHECKED Then
                    l = Count_Gas(Near_Point(LEFT, p))
                    Else
                    l = 0
                End If
            End If
        End If
    End If
    
    If rc = EMPTYP Then
        r = 1
        GoTo out
        Else
        If rc = BOLDP Or rc <> p.Color Then
            r = 0
            Else
            If rs = CHECKED And rg = 1 Then
                r = 1
                GoTo out
                Else
                If rs = UNCHECKED Then
                    r = Count_Gas(Near_Point(RIGHT, p))
                    Else
                    r = 0
                End If
            End If
        End If
    End If
    
    If uc = EMPTYP Then
        u = 1
        GoTo out
        Else
        If uc = BOLDP Or uc <> p.Color Then
            u = 0
            Else
            If us = CHECKED And ug = 1 Then
                u = 1
                GoTo out
                Else
                If us = UNCHECKED Then
                    u = Count_Gas(Near_Point(UP, p))
                    Else
                    u = 0
                End If
            End If
        End If
    End If
    
    If dc = EMPTYP Then
        d = 1
        GoTo out
        Else
        If dc = BOLDP Or dc <> p.Color Then
            d = 0
            Else
            If ds = CHECKED And dg = 1 Then
                d = 1
                GoTo out
                Else
                If ds = UNCHECKED Then
                    d = Count_Gas(Near_Point(Down, p))
                    Else
                    d = 0
                End If
            End If
        End If
    End If
    
out:
    If l = 0 And r = 0 And u = 0 And d = 0 Then
        Count_Gas = 0
        Board(p.X, p.Y).Gas = 0
        Board(p.X, p.Y).Status = CHECKED
    Else
        Count_Gas = 1
        Board(p.X, p.Y).Gas = 1
        Board(p.X, p.Y).Status = CHECKED
    
    If (lx > 0 And lx < 20 And ly > 0 And ly < 20) Then
        If Board(lx, ly).Color = p.Color Then
            Board(lx, ly).Gas = 1
            Board(lx, ly).Status = CHECKED
        End If
    End If
    
    If (rx > 0 And rx < 20 And ry > 0 And ry < 20) Then
        If Board(rx, ry).Color = p.Color Then
            Board(rx, ry).Gas = 1
            Board(rx, ry).Status = CHECKED
        End If
    End If
    
    If (ux > 0 And ux < 20 And uy > 0 And uy < 20) Then
        If Board(ux, uy).Color = p.Color Then
            Board(ux, uy).Gas = 1
            Board(ux, uy).Status = CHECKED
        End If
    End If
    
    If (dx > 0 And dx < 20 And dy > 0 And dy < 20) Then
        If Board(dx, dy).Color = p.Color Then
            Board(dx, dy).Gas = 1
            Board(dx, dy).Status = CHECKED
        End If
    End If
    
    End If
Else
Count_Gas = 1
Board(p.X, p.Y).Gas = 1
Board(p.X, p.Y).Status = CHECKED
End If
End Function
Public Function Count_All_Gas() As Integer
Dim i, j, num As Integer
Dim Pickx(200) As Integer
Dim Picky(200) As Integer
Count_All_Gas = 0
num = 0
If ModemState <> LOGIN And SocketState <> CONNECTED Then
'Playing with Myself
If TURN = BLACKP Then
For i = 1 To 19
   For j = 1 To 19
        If Board(i, j).Color = WHITEP Then
            If Count_Gas(Board(i, j)) = 0 Then
                Pickx(num) = Board(i, j).X
                Picky(num) = Board(i, j).Y
                num = num + 1
            End If
        End If
   Next j
Next i
Else
For i = 1 To 19
   For j = 1 To 19
        If Board(i, j).Color = BLACKP Then
            If Count_Gas(Board(i, j)) = 0 Then
                Pickx(num) = Board(i, j).X
                Picky(num) = Board(i, j).Y
                num = num + 1
            End If
        End If
   Next j
Next i
End If
Else
'Modem Connect Process
If S_R = 1 Then
'Playing Stone
For i = 1 To 19
   For j = 1 To 19
        If Board(i, j).Color = TURN Then
            If Count_Gas(Board(i, j)) = 0 Then
                Pickx(num) = Board(i, j).X
                Picky(num) = Board(i, j).Y
                num = num + 1
            End If
        End If
   Next j
Next i
Else
'Not playing stone
For i = 1 To 19
   For j = 1 To 19
        If Board(i, j).Color <> TURN And Board(i, j).Color <> EMPTYP Then
            If Count_Gas(Board(i, j)) = 0 Then
                Pickx(num) = Board(i, j).X
                Picky(num) = Board(i, j).Y
                num = num + 1
            End If
        End If
   Next j
Next i
End If

End If

If num <> 0 Then
    Count_All_Gas = num
    For i = 0 To num
        If (Pickx(i) > 0 And Pickx(i) < 20 And Picky(i) > 0 And Picky(i) < 20) Then
            Board(Pickx(i), Picky(i)).Color = EMPTYP
            Board(Pickx(i), Picky(i)).Status = UNCHECKED
            Board(Pickx(i), Picky(i)).Gas = 1
        End If
    Next i
    Else
    Count_All_Gas = 0
End If
End Function
Public Function No_Gas(p As MyPoint) As Boolean
If (Near_Point(LEFT, p).Color <> 0) _
       And (Near_Point(RIGHT, p).Color <> 0) _
           And (Near_Point(UP, p).Color <> 0) _
               And (Near_Point(Down, p).Color <> 0) Then
                No_Gas = True
               Exit Function
               Else
                No_Gas = False
              
End If
End Function
Public Function Near_Point(Direction As Integer, p As MyPoint) As MyPoint
Dim ix, iy As Integer
Dim tp As MyPoint
Select Case Direction
     Case LEFT:
         ix = p.X - 1
         iy = p.Y
     Case RIGHT:
         ix = p.X + 1
         iy = p.Y
     Case UP:
         ix = p.X
         iy = p.Y - 1
     Case Down:
         ix = p.X
         iy = p.Y + 1
         End Select
     If ix = 0 Or iy = 0 Or ix = 20 Or iy = 20 Then
        tp.Color = BOLDP
        tp.Status = CHECKED
        tp.Gas = 0
     Else
        tp.Color = Board(ix, iy).Color
        tp.Status = Board(ix, iy).Status
        tp.Gas = Board(ix, iy).Gas
     End If
     tp.X = ix
     tp.Y = iy
     Near_Point = tp
End Function
Public Function CountSide(p As MyPoint) As Integer
Dim l, r, u, d As Integer
Dim lx, ly, rx, ry, ux, uy, dx, dy As Integer
Dim lc, ls, lg, rc, rs, rg, uc, us, ug, dc, ds, du, dg As Integer
Dim tp As MyPoint

If p.Color = BLACKP Then
    CountSide = BLACKP
    Exit Function
End If
If p.Color = WHITEP Then
    CountSide = WHITEP
    Exit Function
End If
    
tp.X = p.X
tp.Y = p.Y
tp.Color = p.Color
Do
   lx = Near_Point(LEFT, tp).X
   ly = Near_Point(LEFT, tp).Y
   If lx = 0 Then
        lc = BOLDP
        ls = CHECKED
        lg = 0
    Else
        lc = Board(lx, ly).Color
        ls = Board(lx, ly).Status
        lg = Board(lx, ly).Gas
    End If
    If lc <> EMPTYP Then
    Exit Do
    Else
    tp.X = lx
    tp.Y = ly
    tp.Color = Near_Point(LEFT, p).Color
    End If
Loop

tp.X = p.X
tp.Y = p.Y
tp.Color = p.Color
Do
   rx = Near_Point(RIGHT, tp).X
   ry = Near_Point(RIGHT, tp).Y
   If rx = 20 Then
        rc = BOLDP
        rs = CHECKED
        rg = 0
    Else
        rc = Board(rx, ry).Color
        rs = Board(rx, ry).Status
        rg = Board(rx, ry).Gas
    End If
    If rc <> EMPTYP Then
    Exit Do
    Else
    tp.X = rx
    tp.Y = ry
    tp.Color = Near_Point(RIGHT, p).Color
    End If
Loop

tp.X = p.X
tp.Y = p.Y
tp.Color = p.Color
Do
   ux = Near_Point(UP, tp).X
   uy = Near_Point(UP, tp).Y
   If uy = 0 Then
        uc = BOLDP
        us = CHECKED
        ug = 0
    Else
        uc = Board(ux, uy).Color
        us = Board(ux, uy).Status
        ug = Board(ux, uy).Gas
    End If
    If uc <> EMPTYP Then
    Exit Do
    Else
    tp.X = ux
    tp.Y = uy
    tp.Color = Near_Point(UP, p).Color
    End If
Loop

tp.X = p.X
tp.Y = p.Y
tp.Color = p.Color
Do
   dx = Near_Point(Down, tp).X
   dy = Near_Point(Down, tp).Y
   If dy = 20 Then
        dc = BOLDP
        ds = CHECKED
        dg = 0
    Else
        dc = Board(dx, dy).Color
        ds = Board(dx, dy).Status
        dg = Board(dx, dy).Gas
    End If
    If dc <> EMPTYP Then
    Exit Do
    Else
    tp.X = dx
    tp.Y = dy
    tp.Color = Near_Point(Down, p).Color
    End If
Loop

If (lc = BLACKP Or lc = BOLDP) _
        And (rc = BLACKP Or rc = BOLDP) _
           And (uc = BLACKP Or uc = BOLDP) _
              And (dc = BLACKP Or dc = BOLDP) Then
              CountSide = BLACKP
              Exit Function
End If
If (lc = WHITEP Or lc = BOLDP) _
        And (rc = WHITEP Or rc = BOLDP) _
           And (uc = WHITEP Or uc = BOLDP) _
              And (dc = WHITEP Or dc = BOLDP) Then
              CountSide = WHITEP
              Exit Function
End If
CountSide = EMPTYP
End Function
Public Function Count_All_Side()
Dim i, j As Integer
Dim ba, wa
'ba= area of black
'wa= area of white
Dim ms As String
ba = 0: wa = 0
For i = 1 To 19
      For j = 1 To 19
       If CountSide(Board(i, j)) = BLACKP Then
       ba = ba + 1
       End If
       If CountSide(Board(i, j)) = WHITEP Then
       wa = wa + 1
       End If
       If CountSide(Board(i, j)) = EMPTYP Then
       wa = wa + 0.5
       ba = ba + 0.5
       End If
      Next j
Next i
       ms = "BLACK:   " & ba & " WHITE: " & wa
       MsgBox ms
End Function
Public Function ParseLine(temp As String) As Integer
Dim Cb, Lb, i As Integer
Lb = 1: Cb = 1: i = 1
Do Until Cb = 0
    Cb = InStr(Lb, temp, "|")
   If Cb <> 0 Then
    ParseArray(i) = Mid$(temp, Lb, Cb - Lb)
    i = i + 1
    Lb = Cb + 1
   End If
Loop
ParseLine = i - 1
End Function
Public Sub Pause(second!)
Dim StartTime, EndTime As Variant
StartTime = Timer
EndTime = second! + Timer
Do
DoEvents
Loop Until Timer >= EndTime
End Sub
